Documentation for tmp.H (utils on vectors and other containers)
Status: Closed Start date: 03 Oct 2012

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Documentation Estimated time: 5.30 hours

Target version: CoCoALib-0.99534 Seoul14 Spent time: 5.10 hours

Description

tmp.H includes some useful functions, such as sum, product, ...

but documentation is missing (of course, as it is called "tmp" ;-)

Maybe we should move these functions in utils.H?

History

#1 - 03 Oct 2012 18:07 - John Abbott

- Category set to Documentation

My "gut feeling" is that code in tmp.C should not have official documentation.

However, from a practical point of view it is probably a good idea to develop some documentation for candidate new functions.  Perhaps the

documentation should simply be marked clearly as EXPERIMENTAL (or likely to change or whatever)?

#2 - 02 Apr 2014 09:28 - Anna Maria Bigatti

John Abbott wrote:

My "gut feeling" is that code in tmp.C should not have official documentation.

However, from a practical point of view it is probably a good idea to develop some documentation for candidate new functions.  Perhaps the

documentation should simply be marked clearly as EXPERIMENTAL (or likely to change or whatever)?

 

tmp has some useful functions which should be documented.

Maybe it should be renamed into template

#3 - 02 Apr 2014 09:29 - Anna Maria Bigatti

- Target version set to CoCoALib-0.99533 Easter14

#4 - 07 Apr 2014 18:12 - John Abbott

- Target version changed from CoCoALib-0.99533 Easter14 to CoCoALib-0.99534 Seoul14

#5 - 14 Jul 2014 17:23 - John Abbott
- Status changed from New to Feedback

- Assignee set to John Abbott

- % Done changed from 0 to 90

- Estimated time set to 2.30 h

Renamed file to UtilsTemplate.H.

Moved LexCmp3 into the file (from utils.H).

Added doc (& moved doc for LexCmp3).

Added new example ex-UtilsTemplate1.C

Still need to improve HasUniqueOwner so that it works with any container.

#6 - 14 Jul 2014 17:32 - Anna Maria Bigatti

Should also << for vector/list be here?

(now it is in io.H)

#7 - 14 Jul 2014 17:49 - John Abbott

I suppose it makes sense to move them... perhaps I'll think about it overnight before acting.

#8 - 14 Jul 2014 17:53 - John Abbott

HasUniqueOwner should now work with any container.  Checked in.

[I haven't actually made any specific tests, but the standard CoCoALib tests compile and pass]

#9 - 15 Jul 2014 14:47 - John Abbott

Christof does not like the name UtilsTemplates.H; he suggested UtilsContainers.H or UtilsVector.H saying that it would be a more helpful name for

users -- actually most users would presumably just include library.H.  I think he does have a valid point.

He also said that it would make sense to move the printing functions only if the header file name indicated that that is where they would likely be; he

was concerned that they may end up "hidden" inside a header whose name is too vague.

Opinions?

#10 - 15 Jul 2014 15:12 - Anna Maria Bigatti

John Abbott wrote:

Christof does not like the name UtilsTemplates.H; he suggested UtilsContainers.H or UtilsVector.H saying that it would be a more helpful name

for users -- actually most users would presumably just include library.H.  I think he does have a valid point.

 

OK... it would be quite helpful for me, at least.

I find templates scary, whereas I often wonder "where is that funcion on vector defined?" ;-)

(I can think of some other functions I might like to add to it, if we call it UtilsVector..)
#11 - 15 Jul 2014 15:59 - Anna Maria Bigatti

- Subject changed from Documentation for tmp.H to Documentation for tmp.H (utils on vectors and other containers)

#12 - 31 Jul 2014 16:53 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time changed from 2.30 h to 5.30 h

The final (hasty?) decision is the call the file VectorOperations.H (even though most functions in it apply to other C++ containers as well).  The

printing functions for vector and list have been merged into it too -- so the old header files io.H and UtilsTemaplte.H have been removed.

All tests pass.  Documentation and examples have been updated.

Checked in.  Closing.
